Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -5992,113 +6068,79 @@
                                         ) *                                    &
                                      ( w(k,j,i+2) - w(k,j,i-3) )               &
-                                                            )
-
-          ENDDO
-
-          DO  k = nzb_max_l+1, nzt-1
-
-             u_comp                   = u(k+1,j,i) + u(k,j,i) - gu
-             swap_flux_x_local_w(k,j) = u_comp * (                             &
-                            37.0_wp * ( w(k,j,i) + w(k,j,i-1)   )              &
-                          -  8.0_wp * ( w(k,j,i+1) + w(k,j,i-2) )              &
-                          +           ( w(k,j,i+2) + w(k,j,i-3) ) ) * adv_mom_5
-             swap_diss_x_local_w(k,j) = - ABS( u_comp ) * (                    &
-                            10.0_wp * ( w(k,j,i) - w(k,j,i-1)   )              &
-                          -  5.0_wp * ( w(k,j,i+1) - w(k,j,i-2) )              &
-                          +           ( w(k,j,i+2) - w(k,j,i-3) ) ) * adv_mom_5
-
-          ENDDO
-
-       ENDDO
+                                                           )
+
+                ENDDO
+
+                DO  k = nzb_max_l+1, nzt-1
+
+                   u_comp(k)        = u(k+1,j,i) + u(k,j,i) - gu
+                   flux_l_w(k,j,tn) = u_comp(k) * (                            &
+                               37.0_wp * ( w(k,j,i)   + w(k,j,i-1)   )         &
+                             -  8.0_wp * ( w(k,j,i+1) + w(k,j,i-2) )           &
+                             +           ( w(k,j,i+2) + w(k,j,i-3) ) ) * adv_mom_5
+                   diss_l_w(k,j,tn) = - ABS( u_comp(k) ) * (                   &
+                               10.0_wp * ( w(k,j,i)   - w(k,j,i-1)   )         &
+                             -  5.0_wp * ( w(k,j,i+1) - w(k,j,i-2) )           &
+                             +           ( w(k,j,i+2) - w(k,j,i-3) ) ) * adv_mom_5
+
+                ENDDO
+
+             ENDIF
+
+             IF ( j == nys )  THEN
+                DO  k = nzb+1, nzb_max_l
+
+                   ibit23 = REAL( IBITS(advc_flags_m(k,j-1,i),23,1), KIND = wp )
+                   ibit22 = REAL( IBITS(advc_flags_m(k,j-1,i),22,1), KIND = wp )
+                   ibit21 = REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp )
+
+                   v_comp(k)      = v(k+1,j,i) + v(k,j,i) - gv
+                   flux_s_w(k,tn) = v_comp(k) * (                               &
+                                       ( 37.0_wp * ibit23 * adv_mom_5           &
+                                    +     7.0_wp * ibit22 * adv_mom_3           &
+                                    +              ibit21 * adv_mom_1           &
+                                       ) *                                      &
+                                        ( w(k,j,i)   + w(k,j-1,i) )             &
+                                -      (  8.0_wp * ibit23 * adv_mom_5           &
+                                    +              ibit22 * adv_mom_3           &
+                                       ) *                                      &
+                                        ( w(k,j+1,i) + w(k,j-2,i) )             &
+                                +      (           ibit23 * adv_mom_5           &
+                                       ) *                                      &
+                                        ( w(k,j+2,i) + w(k,j-3,i) )             &
+                                                  )
+
+                   diss_s_w(k,tn) = - ABS( v_comp(k) ) * (                      &
+                                       ( 10.0_wp * ibit23 * adv_mom_5           &
+                                    +     3.0_wp * ibit22 * adv_mom_3           &
+                                    +              ibit21 * adv_mom_1           &
+                                       ) *                                      &
+                                        ( w(k,j,i)   - w(k,j-1,i) )             &
+                                -      (  5.0_wp * ibit23 * adv_mom_5           &
+                                    +              ibit22 * adv_mom_3           &
+                                       ) *                                      &
+                                        ( w(k,j+1,i) - w(k,j-2,i) )             &
+                                +      (           ibit23 * adv_mom_5           &
+                                       ) *                                      &
+                                        ( w(k,j+2,i) - w(k,j-3,i) )             &
+                                                           )
+
+                ENDDO
+
+                DO  k = nzb_max_l+1, nzt-1
+
+                   v_comp(k)      = v(k+1,j,i) + v(k,j,i) - gv
+                   flux_s_w(k,tn) = v_comp(k) * (                               &
+                              37.0_wp * ( w(k,j,i) + w(k,j-1,i)   )             &
+                            -  8.0_wp * ( w(k,j+1,i) +w(k,j-2,i)  )             &
+                            +           ( w(k,j+2,i) + w(k,j-3,i) ) ) * adv_mom_5
+                   diss_s_w(k,tn) = - ABS( v_comp(k) ) * (                      &
+                              10.0_wp * ( w(k,j,i) - w(k,j-1,i)   )             &
+                            -  5.0_wp * ( w(k,j+1,i) - w(k,j-2,i) )             &
+                            +           ( w(k,j+2,i) - w(k,j-3,i) ) ) * adv_mom_5
+
+                ENDDO
+             ENDIF
 #endif
-
-       !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, gu, gv) &
-       !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
-       !$ACC PRIVATE(ibit18, ibit19, ibit20, ibit21, ibit22, ibit23) &
-       !$ACC PRIVATE(ibit18_l, ibit19_l, ibit20_l) &
-       !$ACC PRIVATE(ibit21_s, ibit22_s, ibit23_s) &
-       !$ACC PRIVATE(ibit24, ibit25, ibit26) &
-       !$ACC PRIVATE(flux_r, diss_r, flux_l, diss_l) &
-       !$ACC PRIVATE(flux_n, diss_n, flux_s, diss_s) &
-       !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
-       !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s, w_comp) &
-       !$ACC PRESENT(advc_flags_m) &
-       !$ACC PRESENT(u, v, w) &
-       !$ACC PRESENT(rho_air, drho_air_zw, ddzu) &
-       !$ACC PRESENT(tend) &
-       !$ACC PRESENT(hom(nzb+1:nzb_max_l,1,3,0)) &
-       !$ACC PRESENT(weight_substep(intermediate_timestep_count)) &
-       !$ACC PRESENT(sums_ws2_ws_l(nzb+1:nzb_max_l,0))
-       DO i = nxl, nxr
-
-#ifndef _OPENACC
-          j = nys
-          DO  k = nzb+1, nzb_max_l
-
-             ibit23 = REAL( IBITS(advc_flags_m(k,j-1,i),23,1),  KIND = wp )
-             ibit22 = REAL( IBITS(advc_flags_m(k,j-1,i),22,1), KIND = wp )
-             ibit21 = REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp )
-
-             v_comp                 = v(k+1,j,i) + v(k,j,i) - gv
-             swap_flux_y_local_w(k) = v_comp * (                               &
-                                    ( 37.0_wp * ibit23 * adv_mom_5             &
-                                 +     7.0_wp * ibit22 * adv_mom_3             &
-                                 +              ibit21 * adv_mom_1             &
-                                    ) *                                        &
-                                     ( w(k,j,i)   + w(k,j-1,i) )               &
-                             -      (  8.0_wp * ibit23 * adv_mom_5             &
-                                 +              ibit22 * adv_mom_3             &
-                                    ) *                                        &
-                                     ( w(k,j+1,i) + w(k,j-2,i) )               &
-                             +      (           ibit23 * adv_mom_5             &
-                                    ) *                                        &
-                                     ( w(k,j+2,i) + w(k,j-3,i) )               &
-                                               )
-
-             swap_diss_y_local_w(k) = - ABS( v_comp ) * (                      &
-                                    ( 10.0_wp * ibit23 * adv_mom_5             &
-                                 +     3.0_wp * ibit22 * adv_mom_3             &
-                                 +              ibit21 * adv_mom_1             &
-                                    ) *                                        &
-                                     ( w(k,j,i)   - w(k,j-1,i) )               &
-                             -      (  5.0_wp * ibit23 * adv_mom_5             &
-                                 +              ibit22 * adv_mom_3             &
-                                    ) *                                        &
-                                     ( w(k,j+1,i) - w(k,j-2,i) )               &
-                             +      (           ibit23 * adv_mom_5             &
-                                    ) *                                        &
-                                     ( w(k,j+2,i) - w(k,j-3,i) )               &
-                                                        )
-
-          ENDDO
-
-          DO  k = nzb_max_l+1, nzt-1
-
-             v_comp                 = v(k+1,j,i) + v(k,j,i) - gv
-             swap_flux_y_local_w(k) = v_comp * (                               &
-                           37.0_wp * ( w(k,j,i) + w(k,j-1,i)   )               &
-                         -  8.0_wp * ( w(k,j+1,i) +w(k,j-2,i)  )               &
-                         +           ( w(k,j+2,i) + w(k,j-3,i) ) ) * adv_mom_5
-             swap_diss_y_local_w(k) = - ABS( v_comp ) * (                      &
-                           10.0_wp * ( w(k,j,i) - w(k,j-1,i)   )               &
-                         -  5.0_wp * ( w(k,j+1,i) - w(k,j-2,i) )               &
-                         +           ( w(k,j+2,i) - w(k,j-3,i) ) ) * adv_mom_5
-
-          ENDDO
-#endif
-
-          DO  j = nys, nyn
-
-!
-!--          The lower flux has to be calculated explicitly for the tendency
-!--          at the first w-level. For topography wall this is done implicitely
-!--          by advc_flags_m.
-             k      = nzb + 1
-             w_comp = w(k,j,i) + w(k-1,j,i)
-             flux_d = w_comp       * rho_air(k)                                &
-                    * ( w(k,j,i) + w(k-1,j,i) ) * adv_mom_1
-             diss_d = -ABS(w_comp) * rho_air(k)                                &
-                    * ( w(k,j,i) - w(k-1,j,i) ) * adv_mom_1
-
              DO  k = nzb+1, nzb_max_l
 
@@ -6107,6 +6149,6 @@
                 ibit18 = REAL( IBITS(advc_flags_m(k,j,i),18,1), KIND = wp )
 
-                u_comp = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                flux_r = u_comp * (                                            &
+                u_comp(k) = u(k+1,j,i+1) + u(k,j,i+1) - gu
+                flux_r(k) = u_comp(k) * (                                      &
                           ( 37.0_wp * ibit20 * adv_mom_5                       &
                        +     7.0_wp * ibit19 * adv_mom_3                       &
@@ -6121,7 +6163,7 @@
                           ) *                                                  &
                                  ( w(k,j,i+3) + w(k,j,i-2) )                   &
-                                     )
-
-                diss_r = - ABS( u_comp ) * (                                   &
+                                        )
+
+                diss_r(k) = - ABS( u_comp(k) ) * (                             &
                           ( 10.0_wp * ibit20 * adv_mom_5                       &
                        +     3.0_wp * ibit19 * adv_mom_3                       &
@@ -6136,5 +6178,5 @@
                           ) *                                                  &
                                  ( w(k,j,i+3) - w(k,j,i-2) )                   &
-                                              )
+                                                 )
 
 #ifdef _OPENACC
@@ -6145,6 +6187,6 @@
                 ibit18_l = REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp )
 
-                u_comp_l = u(k+1,j,i) + u(k,j,i) - gu
-                flux_l   = u_comp_l * (                                        &
+                u_comp_l           = u(k+1,j,i) + u(k,j,i) - gu
+                flux_l_w(k,j,tn)   = u_comp_l * (                              &
                                       ( 37.0_wp * ibit20_l * adv_mom_5         &
                                    +     7.0_wp * ibit19_l * adv_mom_3         &
@@ -6159,7 +6201,7 @@
                                       ) *                                      &
                                      ( w(k,j,i+2) + w(k,j,i-3) )               &
-                                                 )
-
-                diss_l   = - ABS( u_comp_l ) * (                               &
+                                                )
+
+                diss_l_w(k,j,tn)   = - ABS( u_comp_l ) * (                     &
                                         ( 10.0_wp * ibit20_l * adv_mom_5       &
                                      +     3.0_wp * ibit19_l * adv_mom_3       &
@@ -6174,8 +6216,5 @@
                                         ) *                                    &
                                      ( w(k,j,i+2) - w(k,j,i-3) )               &
-                                                            )
-#else
-                flux_l = swap_flux_x_local_w(k,j)
-                diss_l = swap_diss_x_local_w(k,j)
+                                                         )
 #endif
 
@@ -6185,6 +6224,6 @@
                 ibit21 = REAL( IBITS(advc_flags_m(k,j,i),21,1), KIND = wp )
 
-                v_comp = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                flux_n = v_comp * (                                            &
+                v_comp(k) = v(k+1,j+1,i) + v(k,j+1,i) - gv
+                flux_n(k) = v_comp(k) * (                                      &
                           ( 37.0_wp * ibit23 * adv_mom_5                       &
                        +     7.0_wp * ibit22 * adv_mom_3                       &
@@ -6199,7 +6238,7 @@
                           ) *                                                  &
                                  ( w(k,j+3,i) + w(k,j-2,i) )                   &
-                                     )
-
-                diss_n = - ABS( v_comp ) * (                                   &
+                                        )
+
+                diss_n(k) = - ABS( v_comp(k) ) * (                             &
                           ( 10.0_wp * ibit23 * adv_mom_5                       &
                        +     3.0_wp * ibit22 * adv_mom_3                       &
@@ -6214,5 +6253,5 @@
                           ) *                                                  &
                                  ( w(k,j+3,i) - w(k,j-2,i) )                   &
-                                              )
+                                                 )
 
 #ifdef _OPENACC
@@ -6223,6 +6262,6 @@
                 ibit21_s = REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp )
 
-                v_comp_s = v(k+1,j,i) + v(k,j,i) - gv
-                flux_s   = v_comp_s * (                                        &
+                v_comp_s         = v(k+1,j,i) + v(k,j,i) - gv
+                flux_s_w(k,tn)   = v_comp_s * (                                &
                                     ( 37.0_wp * ibit23_s * adv_mom_5           &
                                  +     7.0_wp * ibit22_s * adv_mom_3           &
@@ -6237,7 +6276,7 @@
                                     ) *                                        &
                                      ( w(k,j+2,i) + w(k,j-3,i) )               &
-                                               )
-
-                diss_s   = - ABS( v_comp_s ) * (                               &
+                                              )
+
+                diss_s_w(k,tn)   = - ABS( v_comp_s ) * (                       &
                                     ( 10.0_wp * ibit23_s * adv_mom_5           &
                                  +     3.0_wp * ibit22_s * adv_mom_3           &
@@ -6253,9 +6292,76 @@
                                      ( w(k,j+2,i) - w(k,j-3,i) )               &
                                                         )
-#else
-                flux_s = swap_flux_y_local_w(k)
-                diss_s = swap_diss_y_local_w(k)
 #endif
-
+             ENDDO
+
+             DO  k = nzb_max_l+1, nzt-1
+
+                u_comp(k) = u(k+1,j,i+1) + u(k,j,i+1) - gu
+                flux_r(k) = u_comp(k) * (                                      &
+                      37.0_wp * ( w(k,j,i+1) + w(k,j,i)   )                    &
+                    -  8.0_wp * ( w(k,j,i+2) + w(k,j,i-1) )                    &
+                    +           ( w(k,j,i+3) + w(k,j,i-2) ) ) * adv_mom_5
+
+                diss_r(k) = - ABS( u_comp(k) ) * (                             &
+                      10.0_wp * ( w(k,j,i+1) - w(k,j,i)   )                    &
+                    -  5.0_wp * ( w(k,j,i+2) - w(k,j,i-1) )                    &
+                    +           ( w(k,j,i+3) - w(k,j,i-2) ) ) * adv_mom_5
+
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                u_comp_l           = u(k+1,j,i) + u(k,j,i) - gu
+                flux_l_w(k,j,tn)   = u_comp_l * (                              &
+                            37.0_wp * ( w(k,j,i)   + w(k,j,i-1)   )            &
+                          -  8.0_wp * ( w(k,j,i+1) + w(k,j,i-2) )              &
+                          +           ( w(k,j,i+2) + w(k,j,i-3) ) ) * adv_mom_5
+                diss_l_w(k,j,tn)   = - ABS( u_comp_l ) * (                     &
+                            10.0_wp * ( w(k,j,i)   - w(k,j,i-1)   )            &
+                          -  5.0_wp * ( w(k,j,i+1) - w(k,j,i-2) )              &
+                          +           ( w(k,j,i+2) - w(k,j,i-3) ) ) * adv_mom_5
+#endif
+
+                v_comp(k) = v(k+1,j+1,i) + v(k,j+1,i) - gv
+                flux_n(k) = v_comp(k) * (                                      &
+                      37.0_wp * ( w(k,j+1,i) + w(k,j,i)   )                    &
+                    -  8.0_wp * ( w(k,j+2,i) + w(k,j-1,i) )                    &
+                    +           ( w(k,j+3,i) + w(k,j-2,i) ) ) * adv_mom_5
+
+                diss_n(k) = - ABS( v_comp(k) ) * (                             &
+                      10.0_wp * ( w(k,j+1,i) - w(k,j,i)   )                    &
+                    -  5.0_wp * ( w(k,j+2,i) - w(k,j-1,i) )                    &
+                    +           ( w(k,j+3,i) - w(k,j-2,i) ) ) * adv_mom_5
+
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                v_comp_s         = v(k+1,j,i) + v(k,j,i) - gv
+                flux_s_w(k,tn)   = v_comp_s * (                                &
+                           37.0_wp * ( w(k,j,i)   + w(k,j-1,i) )               &
+                         -  8.0_wp * ( w(k,j+1,i) + w(k,j-2,i)  )              &
+                         +           ( w(k,j+2,i) + w(k,j-3,i) ) ) * adv_mom_5
+                diss_s_w(k,tn)   = - ABS( v_comp_s ) * (                       &
+                           10.0_wp * ( w(k,j,i)   - w(k,j-1,i) )               &
+                         -  5.0_wp * ( w(k,j+1,i) - w(k,j-2,i) )               &
+                         +           ( w(k,j+2,i) - w(k,j-3,i) ) ) * adv_mom_5
+#endif
+             ENDDO
+!
+!--          Now, compute vertical fluxes. Split loop into a part treating the
+!--          lowest grid points with indirect indexing, a main loop without
+!--          indirect indexing, and a loop for the uppermost grip points with
+!--          indirect indexing. This allows better vectorization for the main loop.
+!--          First, compute the flux at model surface, which need has to be
+!--          calculated explicitly for the tendency at
+!--          the first w-level. For topography wall this is done implicitely by
+!--          advc_flags_m.
+             k         = nzb + 1
+             w_comp(k) = w(k,j,i) + w(k-1,j,i)
+             flux_t(0) = w_comp(k)       * rho_air(k)                          &
+                       * ( w(k,j,i) + w(k-1,j,i) ) * adv_mom_1
+             diss_t(0) = -ABS(w_comp(k)) * rho_air(k)                          &
+                       * ( w(k,j,i) - w(k-1,j,i) ) * adv_mom_1
+
+             DO  k = nzb+1, nzb+1
 !
 !--             k index has to be modified near bottom and top, else array
